diff --git a/zebra/main.c b/zebra/main.c
index 3de97943fd16..3a8aa4cdaf25 100644
--- a/zebra/main.c
+++ b/zebra/main.c
@@ -204,6 +204,8 @@ static void sigint(void)
 	 */
 	zebra_routemap_finish();
 
+	rib_update_finish();
+
 	list_delete(&zrouter.client_list);
 
 	/* Indicate that all new dplane work has been enqueued. When that
diff --git a/zebra/rib.h b/zebra/rib.h
index 99f52bcd4e43..c9bd2b8c957f 100644
--- a/zebra/rib.h
+++ b/zebra/rib.h
@@ -331,6 +331,7 @@ enum rib_update_event {
 	RIB_UPDATE_OTHER,
 	RIB_UPDATE_MAX
 };
+void rib_update_finish(void);
 
 int route_entry_update_nhe(struct route_entry *re,
 			   struct nhg_hash_entry *new_nhghe);
diff --git a/zebra/zebra_rib.c b/zebra/zebra_rib.c
index adc6a904f1c8..1540bbdd553e 100644
--- a/zebra/zebra_rib.c
+++ b/zebra/zebra_rib.c
@@ -4365,6 +4365,22 @@ static void rib_update_handler(struct thread *thread)
  */
 static struct thread *t_rib_update_threads[RIB_UPDATE_MAX];
 
+void rib_update_finish(void)
+{
+	int i;
+
+	for (i = RIB_UPDATE_KERNEL; i < RIB_UPDATE_MAX; i++) {
+		if (thread_is_scheduled(t_rib_update_threads[i])) {
+			struct rib_update_ctx *ctx;
+
+			ctx = EVENT_ARG(t_rib_update_threads[i]);
+
+			rib_update_ctx_fini(&ctx);
+			EVENT_OFF(t_rib_update_threads[i]);
+		}
+	}
+}
+
 /* Schedule a RIB update event for all vrfs */
 void rib_update(enum rib_update_event event)
 {
@@ -4373,6 +4389,9 @@ void rib_update(enum rib_update_event event)
 	if (thread_is_scheduled(t_rib_update_threads[event]))
 		return;
 
+	if (zebra_router_in_shutdown())
+		return;
+
 	ctx = rib_update_ctx_init(0, event);
 	ctx->vrf_all = true;
 
